#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "juego.h"
using namespace std;

const char ope[]={'+', '-', '*', '/'};

int Juego::random(int min, int max){
	int n, rango;
	rango=max-min+1;
	n=rand () % rango + min;
	return n;
}

bool Juego::isCorrecto(int res){
	bool correcto=false;
	if(sol==res)
		correcto=true;
	return correcto;
}

Juego::Juego(){
	srand(time(NULL));
}

void Juego::jugar(){
	tInicio = time(NULL);
	numOperaciones=0;
	tiempo=opciones.getTiempo();
	aciertosNivel=0;
	cambioNivel=2;
	nivel=opciones.getMinNivel();
	int res;
	bool tipo, fin;
	puntos.reiniciarPuntuacion();
	system("clear");
	do{
		setOperacion(nivel);
		mostrarOperacion();
		cin >> res;
		tipo=isCorrecto(res);
		mostrarMensaje(tipo);
		numOperaciones++;
		fin=isFin();
		if(!fin){
			if(tipo==true)
				puntos.sumarAcierto(nivel);
			actualizarNivel(tipo);
		}
	}while(fin==false);
		comprobarDesbloqueo();
}

void Juego::comprobarDesbloqueo(){
	int torneo;
	if(opciones.isJuego(2)){
		torneo=opciones.getTorneo();
		if(torneo<=2 && tiempo<=60){
			opciones.desbloquearNivel(torneo+1);
		}else if(torneo==3 && tiempo<=90)
			opciones.desbloquearNivel(torneo+1);
		else if(torneo>=4 && tiempo<=120)
			opciones.desbloquearNivel(torneo+1);
	}
}

bool Juego::isFin(){
	bool fin=false;
	if(opciones.isTipo()==0){
		tActual= time(NULL);
		if(tActual >= tInicio+tiempo)
			fin=true;
	}else
		if(numOperaciones==opciones.getNumOperaciones()){
			tActual=time(NULL);
			tiempo=tActual-tInicio;
			fin=true;
		}
	return fin;
}

int Juego::getTiempo(){
	int time;
	time = tActual - tInicio;
	return time;
}

void Juego::setOperacion(int nivel){
	int min;
	int max;
	if(opciones.getTorneo()<=4 && opciones.isJuego(3)){
		min=opciones.getTorneo()-1;
		max=min;
	}else{
		min=0;
		max=3;
		if(nivel==1)
			max=1;
	}
	ope1=random(min, max);
	min=2;
	max=9;
	if(nivel>=3 || (nivel==2 && ope1<=1)){
		min=11;
		max=99;
	}
	n=random(min, max);
	min=2;
	max=9;
	if(nivel>=3 && ope1<2){
			min=11;
			max=99;
		}
	n2=random(min, max);
	if(ope[ope1]=='-' && n2>n)
		cambiarPosicion();
	if(ope[ope1]=='/'){
		getResultado();
		n=sol*n2;
	}
	if(nivel>=4){
		if(ope1==0 || ope1==1){
			ope2=2;
			min=2;
			max=9;
		}else{
			ope2=0;
			min=51;
			max=99;
		}
		n3=random(min, max);
	}
	getResultado();
}

void Juego::cambiarPosicion(){
	int num1=n;
	int num2=n2;
	n=num2;
	n2=num1;
}

int Juego::getResultado(){
	if(nivel<4 ){
		switch(ope[ope1]){
			case '+': sol=n2*n3+n;
			break;
			case '-': sol=n2*n3-n;
			break;
			case '*': sol=n*n2+n3;
			break;
			case '/': sol=n/n2+n3;
			break;
		}
	}else{
		switch(ope[ope1]){
			case '+': sol=n+n2;
			break;
			case '-': sol=n-n2;
			break;
			case '*': sol=n*n2;
			break;
			case '/': sol=n/n2;
			break;
		}

	}
}


void Juego::mostrarMensaje(bool tipo){
	if(tipo==true)
		cout << "Correcto\n";
	else{
		cout << "Incorrecto\n";
		if(opciones.isSonido())
			cout << '\a';
	}
}

void Juego::mostrarOperacion(){
	if(nivel<=3)
		cout << n << ope[ope1] << n2 << " = ";
	else
		cout << n << ope[ope1] << n2 << ope[ope2] << n3 << " = ";
}

void Juego::actualizarNivel(bool tipo){
	if(tipo==false){
		if(nivel>opciones.getMinNivel()){
			nivel--;
			aciertosNivel=0;
		}
	}else{
		aciertosNivel++;
		if(aciertosNivel==cambioNivel){
			if(nivel<opciones.getMaxNivel()){
				nivel++;
				aciertosNivel=0;
			}
		}
	}
}

void Juego::setOpciones(Opciones partida){
	opciones=partida;
}

Opciones Juego::getOpciones(){
	return opciones;
}
